package cs108.immutability;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public final class ImmutableMatrix {
    private final List<List<Double>> m;

    public ImmutableMatrix(List<List<Double>> m) {
        List<List<Double>> mc = new ArrayList<>();
        for (List<Double> r: m) {
            ArrayList<Double> rc = new ArrayList<>(r);
            mc.add(Collections.unmodifiableList(rc));
        }
        this.m = Collections.unmodifiableList(mc);
    }

    public List<List<Double>> asArray() {
        return m;
    }
}
