package cs108.words;

import static java.nio.charset.StandardCharsets.UTF_8;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public final class LongestWord {

    public static void main(String[] args) throws IOException {
        System.out.print("Chargement des mots...");
        List<String> words = loadWords("mots.txt");
        System.out.println("ok, " + words.size() + " mots chargés!");

        System.out.print("Recherche du mot le plus long...");
        String longestWord = longestWord(words);
        System.out.println("trouvé : " + longestWord);
    }

    private static List<String> loadWords(String fileName) throws IOException {
        try (BufferedReader r =
                new BufferedReader(
                        new InputStreamReader(
                                new FileInputStream(fileName), UTF_8))) {
            List<String> ws = new ArrayList<>(); // essayer avec LinkedList
            String w;
            while ((w = r.readLine()) != null)
                ws.add(w); // essayer avec ws.add(0, w)
            return ws;
        }
    }

    private static String longestWord(List<String> words) {
        String longestWord = "";
        for (int i = 0; i < words.size(); ++i) {
            String w = words.get(i);
            if (w.length() > longestWord.length())
                longestWord = w;
        }
        return longestWord;
    }
}
